/**
 * @file
 */

(function ($, Drupal, drupalSettings) {
  'use strict';
  Drupal.behaviors.bootstrap_datetime_picker = {
    attach: function (context, settings) {
      $(context).find('input[data-bootstrap-date-time]').once('datePicker').each(function () {
        tempusDominus.extend(tempusDominus.plugins.customDateFormat);
        var picker = new tempusDominus.TempusDominus($(this).parent()[0], settings.bootstrap_datetime_picker);
        var input = $(this);
        var options = {localization: {format: input.data('format')}};
        if (input.data('disable-days')) {
          update_options(options, 'daysOfWeekDisabled', 'restrictions', input.data('disable-days'));
        }
        if (input.data('min-date')) {
          update_options(options, 'minDate', 'restrictions', input.data('min-date'));
        }
        if (input.data('max-date')) {
          update_options(options, 'maxDate', 'restrictions', input.data('max-date'));
        }
        if (input.data('exclude-date')) {
          update_options(options, 'disabledDates', 'restrictions', input.data('exclude-date'));
        }
        if (input.data('disabled-hours')) {
          update_options(options, 'disabledHours', 'restrictions', input.data('disabled-hours'));
        }

        if (input.data('bootstrap-date-time') == 'date') {
          options['display'] = {};
          options['display']['components'] = {};
          options['display']['components']['clock'] = false;
          options['display']['components']['hours'] = false;
          options['display']['components']['minutes'] = false;
          options['display']['components']['seconds'] = false;
        }
        else if (input.data('bootstrap-date-time') == 'time') {
          options['display'] = {};
          options['display']['components'] = {};
          options['display']['components']['calendar'] = false;
          options['display']['components']['date'] = false;
          options['display']['components']['month'] = false;
          options['display']['components']['year'] = false;
          options['display']['components']['decades'] = false;
          options['display']['viewMode'] = 'clock';
        }
        picker.updateOptions(options);
      });

      function update_options(options, data, parent, value) {
        if (options[parent] == undefined) {
          options[parent] = {};
        }
        options[parent][data] = value;
      }
    },
  };

})(jQuery, Drupal, drupalSettings);
